<?php

// OpenSSL wrapper class example
require_once(dirname(__FILE__).'/class_OpenSSL.php');
$openssl = &new OpenSSL();

// generate keypair
$ssl->set_distinguished_name('CA','BC','Nanaimo','YourCo Inc','Web team','Your Name','you@example.com');
$ssl->generate_keypair('secretpassword');
echo "Private key: ".$ssl->private_key."\n";
echo "Certificate: ".$ssl->certificate."\n";
echo "CSR: ".$ssl->csr."\n";

// now, encrypt some data with your public key, which can only be decrypted by your
// private key
$mydata = "secret data";
$encrypted = $ssl->public_key_encrypt($data,$ssl->certificate);
echo "Encrypted data: ".$encrypted."\n";

$decrypted = $ssl->private_key_decrypt($encrypted,$ssl->private_key,'secretpassword');
echo "Decrypted data: ".$decrypted." (should be: ".$mydata.")\n";


// now, encrypt some data with your private key, which can only be decrypted by your
// public key (essentially validating your identity)
$mydata = "secret data";
$encrypted = $ssl->private_key_encrypt($data,$ssl->private_key,'secretpassword');
echo "Encrypted data: ".$encrypted."\n";

$decrypted = $ssl->public_key_decrypt($encrypted,$ssl->certificate);
echo "Decrypted data: ".$decrypted." (should be: ".$mydata.")\n";


?>
